import {useEffect,useState} from 'react';
import { useDispatch,useSelector } from 'react-redux'
import { Layout } from 'antd';
import AHeader from '../AHeader'
import AMenu from '../AMenu'
import ATabs from '../ATabs'
import apiObj from '@api/index';
import { setStatusList, setHisTypeList, setTitleList, setDataList} from '@reducers/staticInfo';

const {  Content, Sider } = Layout;
const {post,api,xPost} = apiObj;
const propTypes = {

}
const defaultProps = {};

function PageLayout(){
    const dispatch = useDispatch();
    const staticInfo =useSelector(state => {
        return state.staticInfo;
    });
    function getStaticInfos() {
        const { hisTypeList, statusList, titleList, dataList } = staticInfo;
        // if ([...hisTypeList, ...statusList, ...titleList, ...dataList].length > 0) {
        //     return;
        // }
        post(api.getManagerBoxInfo).then((res) => {
            if (res.data.code === 200) {
                const data = res.data.data;
                dispatch(setHisTypeList(data[43]||data[45]));       //非单家医院为医院类型43，单家医院为病区45
                dispatch(setStatusList(data[47]));
                dispatch(setTitleList(data[40]));
                dispatch(setDataList(data[48]));
            }
        })
    }
    useEffect(()=>{
        getStaticInfos()
    },[]);
    return (
        <Layout>
            <AHeader></AHeader>
            <Layout>
                <Sider className='page-sider'>
                    <AMenu></AMenu>
                </Sider>
                <Content className='page-content'>
                    <ATabs></ATabs>
                </Content>
            </Layout>
        </Layout>
    )
}

PageLayout.propTypes = propTypes;
PageLayout.defaultProps = defaultProps;
export default PageLayout;