import { createSlice } from '@reduxjs/toolkit';

export const slice = createSlice({
    name: 'tabPanes',
    initialState: {
        activeTab: '',
        panes:[]
    },
    reducers: {
        close: (state,action) => {        //关闭tab
            state.panes.splice(action.payload.del,1);
            state.activeTab = action.payload.active;
        },
        closeOther:(state,action) => {        //关闭其他tab
            const pane = state.panes[action.payload.del];
            state.panes = [pane];
            //state.activeTab = action.payload.active;
        },
        add: (state,action) => {        //打开新tab
            state.panes.push(action.payload);
            state.activeTab = action.payload.key;
        },
        active:(state,action) => {       //切换tab
            state.activeTab = action.payload;
        },
        panesNow: (state, action) => {       //切换tab
            state.panes = [];
        },
    },
});

export const { close, closeOther, active, add, panesNow } = slice.actions;

export default slice.reducer;
