import { message } from 'antd';
//统一处理请求成功、失败

function handleResponse(res, callback, error) {
    if (res.data.code === 200) {
        callback()
    } else {
        message.warning('操作失败' || res.data.msg);
        error();
    }
}

function pickCheckedTreeIds(data, menuIds = [], resourceIds = []) {
    let arr = data.children;
    if (data.relation === '1') {
        data.softwareMenuId && menuIds.push(data.softwareMenuId);
        data.softwareResourceId && resourceIds.push(data.softwareResourceId);
    }
    if (arr) {
        arr.map((it) => {
            pickCheckedTreeIds(it, menuIds, resourceIds);
        });
    }
    return {
        id: data.softwareId,
        name: data.softwareName,
        softwareMenuIds: menuIds,
        softwareResourceIds: resourceIds
    }
}
// 处理组织结构数据
function organizationData(arr) {
    arr.forEach(item => {
        item.value = item.hospitalId
        item.title = item.hospitalName
        if (!item.children && item.depts) {
            item.depts.forEach(it => {
                it.value = item.parentId + '-' + it.deptId
            })
            item.children = JSON.parse(JSON.stringify(item.depts).replace(/deptName/g, 'title').replace(/deptId/g, 'value'))
            return
        }
        if (item.children) {
            organizationData(item.children)
        }
    })
    return arr
}

// 去重
function unique(arr) {
    return arr.filter(function (item, index, arr) {
        return arr.indexOf(item, 0) === index;
    });
}
//时间获取
function getTimeDetail() {
    const d = new Date();
    const days = ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"];
    let sec = d.getSeconds()
    let min = d.getMinutes()
    let hour = d.getHours()
    let str = `${d.getFullYear()}年${d.getMonth() + 1}月${d.getDate()}日 / ${days[d.getDay()]} / ${hour > 9 ? hour : '0' + hour}:${min > 9 ? min : '0' + min}:${sec > 9 ? sec : '0' + sec}`
    return str;
}

const obj = {
    handleResponse,
    pickCheckedTreeIds,
    organizationData,
    getTimeDetail,
    unique
};
export default obj;